<?php
if (!defined('WM_LOGINED') || !is_object($sesshandle))
	die('the system occurs error, please login it');

require('../inc/datectrllib.php');
require('../inc/class.ftpfolder.php');
require('../inc/class.ftpshare.php');

if ($session_value['netdiskcontrol'] == 0) {
	do_redirect('main.php?sessid='.$sessid.'&act=error&err=99&retid='.$retid);
	exit;
}

if (empty($internet_location))
	$internet_location = my_gethttpurl();

$ftphandle = new FtpFolder;
$ftphandle->home_directory = $session_value['homedirectory'];
$ftphandle->ftp_home_directory = $session_value['ftphomedirectory'];

$ftp = new FtpShare($session_value['homedirectory']);

$ftpfolder = $sesscache_value['ftplist']['ftpfolder'];
if ($ftpfolder == '' || !$ftphandle->folder_is_safe($ftpfolder))
	$ftpfolder = '/';

switch($opt){
case 'getshare':
	$share = $ftp->GetShare();
	$shareenddate = $share['enddate'] ? date('Ymd', $share['enddate']) : '';

	if ($share['user'] == '')
		$share['user'] = $session_value['user'];

	echo json_encode(array(
		'result' => 'ok',
		'enddate' => $shareenddate,
		'user' => $share['user'],
		'password' => Crypt_Decode($share['password'])
	));
	exit;
	break;
case 'setshare':
	if ($endyear == '' || $endmonth == '' || $endday == '')	
		$enddate = '';
	else
		$enddate = mktime(0, 0, 0, $endmonth, $endday, $endyear);
	
	$user = ($user != '') ? $user : '';
	$password = ($password != '') ? Crypt_Encode($password) : '';
	
	$info = array();
	$info['user'] = $user;
	$info['password'] = $password;
	$info['enddate'] = $enddate;
	
	$ret = $ftp->SetShare($info);
	echo json_encode(array('result' => ($ret ? 'ok' : 'err')));
	exit;
	break;
case 'download':
	$filename = str_replace(' ', '+', $filename);
	$filename = base64_decode($filename);
	if (!$ftphandle->folder_is_safe($filename))
		exit;

	$ftpfile = $ftpfolder;
	if (substr($ftpfile, -1) != '/')
		$ftpfile .= '/';
	$ftpfile .= $filename;

	$uagent = strtolower($_SERVER['HTTP_USER_AGENT']);
	$ie_browser = (preg_match('/mozilla/i', $uagent) && (preg_match('/msie/', $uagent) || preg_match('/edge/', $uagent))) 
				|| (preg_match('/trident\//', $uagent) && preg_match('/rv:/', $uagent));

	$filename = $ftphandle->get_filename($filename, true);
	if ($ie_browser)
		$filename = rawurlencode($filename);

	header('Content-type: application/force-download');
	header('Content-Disposition: attachment; filename="'.$filename.'"');

	$localfile = $ftphandle->ftp_home_directory.$ftpfile;

  	if (file_exists($localfile)) {
		$length = filesize($localfile);
		
		header('Accept-Ranges: bytes');
		header('Content-Length: '.$length);

		$fp = fopen($localfile, "rb");
		if ($fp){
			while(!feof($fp))
				echo fread($fp, 655360);
				
			fclose($fp);
		}
    }
	
	exit;
	break;
case 'preview':
	$filename = str_replace(' ', '+', $filename);
	$filename = base64_decode($filename);
	if (!$ftphandle->folder_is_safe($filename))
		exit;

	$ftpfile = $ftpfolder;
	if (substr($ftpfile, -1) != '/')
		$ftpfile .= '/';
	$ftpfile .= $filename;
	
	$suffix = substr($filename, strrpos($filename, '.'));
	$suffix = strtolower($suffix);
	
	if (isset($mimetypes[$suffix]))
		$contenttype = $mimetypes[$suffix];
	else
		$contenttype = 'application/octet-stream';
	
	$uagent = strtolower($_SERVER['HTTP_USER_AGENT']);
	$ie_browser = (preg_match('/mozilla/i', $uagent) && (preg_match('/msie/', $uagent) || preg_match('/edge/', $uagent))) 
				|| (preg_match('/trident\//', $uagent) && preg_match('/rv:/', $uagent));
	
	$filename = $ftphandle->get_filename($filename, true);
	if ($ie_browser)
		$filename = rawurlencode($filename);

	header('Content-Type: '.$contenttype);
  	header('Content-Disposition: inline; filename="'.$filename.'"');
	
	$localfile = $ftphandle->ftp_home_directory.$ftpfile;
  	if (file_exists($localfile))  {
		$content = file_get_contents($localfile);
		if (!$allow_scripts 
			&& (strcasecmp($contenttype, 'text/html') == 0 || strcasecmp($contenttype, 'text/xml') == 0 || strcasecmp($contenttype, 'image/svg+xml') == 0))
			$msghandle->filter_scripts($content);
			
		$length = strlen($content);
		
		header('Accept-Ranges: bytes');
		header('Content-Length: '.$length);
  		
		echo $content;
		
    	unset($content);
    }

	exit;
	break;
case 'flashupload':
case 'html5upload':
case 'upload':
	$bRet = false;
	$size = 0;
	$count = 0;
	
	$ftpquota = $ftphandle->get_ftp_quota();
	if (!is_array($_FILES['uploadfile']['tmp_name'])) {
		foreach ($_FILES as $name => &$upFile) {
			if (substr($name, 0, 10) != 'uploadfile')
				continue;
	
			if ($upFile['error'] == 0 && is_uploaded_file($upFile['tmp_name'])){
				if (file_exists($upFile['tmp_name'])){
					$filename = $upFile['name'];
					$filename = $ftphandle->convert_filename($filename);
					
					$ftpfile = $ftpfolder;
					if (substr($ftpfile, -1) != '/')
						$ftpfile .= '/';
					$ftpfile .= my_basename($filename);
					
					if ($ftpquota['ftpquota'] && $ftpquota['usedftpquota']+$upFile['size'] > $ftpquota['ftpquota'])
						break;
					if ($ftpquota['ftpcount'] && $ftpquota['usedftpcount']+1 > $ftpquota['ftpcount'])
						break;
					
					$localfile = $ftphandle->get_local_file($ftpfile);
					if (move_uploaded_file($upFile['tmp_name'], $localfile)) {
						$ftpquota['usedftpquota'] += $upFile['size'];
						$ftpquota['usedftpcount']++;

						$size += $upFile['size'];
						$count++;

						$bRet = true;
					}
	    		}
			}
		}
	}
	else {
		$filecount = count($_FILES['uploadfile']['tmp_name']);
		for($i = 0; $i < $filecount; $i++) {
			if ($_FILES['uploadfile']['error'][$i] == 0 && is_uploaded_file($_FILES['uploadfile']['tmp_name'][$i])){
				if (file_exists($_FILES['uploadfile']['tmp_name'][$i])){
					$filename = $_FILES['uploadfile']['name'][$i];
					$filename = $ftphandle->convert_filename($filename);
					
					$ftpfile = $ftpfolder;
					if (substr($ftpfile, -1) != '/')
						$ftpfile .= '/';
					$ftpfile .= my_basename($filename);

					if ($ftpquota['ftpquota'] && $ftpquota['usedftpquota']+$_FILES['uploadfile']['size'][$i] > $ftpquota['ftpquota'])
						break;
					if ($ftpquota['ftpcount'] && $ftpquota['usedftpcount']+1 > $ftpquota['ftpcount'])
						break;
					
					$localfile = $ftphandle->get_local_file($ftpfile);
					if (move_uploaded_file($_FILES['uploadfile']['tmp_name'][$i], $localfile)) {
						$ftpquota['usedftpquota'] += $_FILES['uploadfile']['size'][$i];
						$ftpquota['usedftpcount']++;				    	

						$size += $_FILES['uploadfile']['size'][$i];
						$count++;

						$bRet = true;
					}
	    		}
			}
		}
	}
	
	if ($bRet)
		$ftphandle->set_ftp_quota($size, $count, '+');
	
	if ($opt == 'flashupload')
		exit;
	
	echo '<html>
<script language="javascript">
window.parent.o_ftp.uploadend();
</script>
</html>';
	exit;
	break;
case 'create':
	$bRet = false;
	if ($ftphandle->folder_is_safe($newftpfolder)){
		$newftpfolder = trim($newftpfolder);
		$newftpfolder = $ftphandle->convert_filename($newftpfolder);
		
		$ftpfile = $ftpfolder;
		if (substr($ftpfile, -1) != '/')
			$ftpfile .= '/';
		$ftpfile .= $newftpfolder;

		$bRet = $ftphandle->create_folder($ftpfile);
    }
    
	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;
	break;
case 'rename':
	$bRet = false;
	if ($ftphandle->folder_is_safe($newftpfolder)){
		if ($filename == '') {
			$pagesize = $session_value['preferences']['recodeperpage'];
			for ($i = 0; $i < $pagesize; $i++){
				$item = ${'item_'.$i};
				if ($item == '')
					continue;

				$filename = base64_decode($item);
				if ($filename != '')
					break;
			}
		}
		else {
			$filename = base64_decode($filename);
		}
	
		if ($ftphandle->folder_is_safe($filename)){
			$newftpfolder = trim($newftpfolder);
			$newftpfolder = $ftphandle->convert_filename($newftpfolder);
			
			$oldftpfile = $ftpfolder;
			if (substr($oldftpfile, -1) != '/')
				$oldftpfile .= '/';
			$oldftpfile .= $filename;
	
			$newftpfile = $ftpfolder;
			if (substr($newftpfile, -1) != '/')
				$newftpfile .= '/';
			$newftpfile .= $newftpfolder;
			
			$bRet = $ftphandle->modify_folder_file($oldftpfile, $newftpfile);
			if ($bRet)
				$ftp->DeleteShareFile($oldftpfile);
		}
	}
	
	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;		
	break;
case 'delete':
	$bRet = false;
	$count = 0;
	$size = 0;
	$unsharefile = array();
	
	if ($filename == '') {
		$pagesize = $session_value['preferences']['recodeperpage'];
		for ($i = 0; $i < $pagesize; $i++){
			$item = ${'item_'.$i};
			if ($item == '')
				continue;

			$filename = base64_decode($item);
			if ($ftphandle->folder_is_safe($filename)){
				$ftpfile = $ftpfolder;
				if (substr($ftpfile, -1) != '/')
					$ftpfile .= '/';
				$ftpfile .= $filename;
	
				$info = $ftphandle->delete_folder_file($ftpfile);
				if ($info != false) {
					$bRet = true;
	
					$size += $info['size'];
					$count += $info['count'];
	
					$ftp->DeleteShareFile($ftpfile);
				}
			}
		}
	}
	else {
		$filename = base64_decode($filename);
		if ($ftphandle->folder_is_safe($filename)){
			$ftpfile = $ftpfolder;
			if (substr($ftpfile, -1) != '/')
				$ftpfile .= '/';
			$ftpfile .= $filename;

			$info = $ftphandle->delete_folder_file($ftpfile);
			if ($info != false) {
				$bRet = true;

				$size += $info['size'];
				$count += $info['count'];

				$ftp->DeleteShareFile($ftpfile);
			}
		}
	}
	
	if ($bRet) {
		$ftphandle->set_ftp_quota($size, $count, '-');
	}
	
	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;
	break;
case 'renamefolder':
	$bRet = false;
	if ($ftphandle->folder_is_safe($newftpfolder)){
		$filename = base64_decode($filename);
	
		if ($ftphandle->folder_is_safe($filename)){
			$newftpfolder = trim($newftpfolder);
			$newftpfolder = $ftphandle->convert_filename($newftpfolder);
			
			$oldftpfile = $filename;
			
			$pos = strrpos($filename, '/');
			if ($pos === false)
				$newftpfile = '/';
			else
				$newftpfile = substr($filename, 0, $pos+1); 
			$newftpfile .= $newftpfolder;
			
			$bRet = $ftphandle->modify_folder_file($oldftpfile, $newftpfile);
			if ($bRet)
				$ftp->DeleteShareFile($oldftpfile);
		}
	}
	
	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;		
	break;
case 'deletefolder':
	$bRet = false;
	$filename = base64_decode($filename);
	
	if ($ftphandle->folder_is_safe($filename)){
		$info = $ftphandle->delete_folder_file($filename);
		if ($info != false) {
			$bRet = true;

			$size += $info['size'];
			$count += $info['count'];

			$ftp->DeleteShareFile($filename);
		}
	}
	
	if ($bRet) {
		$ftphandle->set_ftp_quota($size, $count, '-');
	}
	
	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;
	break;
case 'copy':
	$count = 0;
	$size = 0;
	$bRet = false;

	$ftpquota = $ftphandle->get_ftp_quota();
	
	$dfolder = base64_decode($toftpfolder);
	if ($ftphandle->folder_is_safe($dfolder) && $ftpfolder != $dfolder){
		if ($filename == '') {
			$pagesize = $session_value['preferences']['recodeperpage'];
			for ($i = 0; $i < $pagesize; $i++){
				$item = ${'item_'.$i};
				if ($item == '')
					continue;

				$filename = base64_decode($item);
				if ($ftphandle->folder_is_safe($filename)){
					$ftpfile = $ftpfolder;
					if (substr($ftpfile, -1) != '/')
						$ftpfile .= '/';
					$ftpfile .= $filename;
	
					$destfile = $dfolder;
					if (substr($destfile, -1) != '/')
						$destfile .= '/';
					$destfile .= $filename;
	
					if ($ftpfile != $dfolder && $ftpfile != $destfile){
						$info = $ftphandle->get_folder_info($ftpfile);
						
						if ($ftpquota['ftpquota'] && $ftpquota['usedftpquota']+$info['size'] > $ftpquota['ftpquota'])
							break;
						if ($ftpquota['ftpcount'] && $ftpquota['usedftpcount']+$info['count'] > $ftpquota['ftpcount'])
							break;
						
						$info = $ftphandle->copy_folder_file($ftpfile, $destfile);
						if ($info != false) {
							$bRet = true;
			
							$size += $info['size'];
							$count += $info['count'];
						}
					}
				}
			}
		}
		else {
			$filename = base64_decode($filename);
			if ($ftphandle->folder_is_safe($filename)){
				$ftpfile = $ftpfolder;
				if (substr($ftpfile, -1) != '/')
					$ftpfile .= '/';
				$ftpfile .= $filename;

				$destfile = $dfolder;
				if (substr($destfile, -1) != '/')
					$destfile .= '/';
				$destfile .= $filename;

				if ($ftpfile != $dfolder && $ftpfile != $destfile){
					$info = $ftphandle->get_folder_info($ftpfile);

					if ($ftpquota['ftpquota'] && $ftpquota['usedftpquota']+$info['size'] > $ftpquota['ftpquota'])
						break;
					if ($ftpquota['ftpcount'] && $ftpquota['usedftpcount']+$info['count'] > $ftpquota['ftpcount'])
						break;
					
					$info = $ftphandle->copy_folder_file($ftpfile, $destfile);
					if ($info != false) {
						$bRet = true;
		
						$size += $info['size'];
						$count += $info['count'];
					}
				}
			}
		}
	}
	
	if ($bRet) {
		$ftphandle->set_ftp_quota($size, $count, '+');
	}

	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;
	break;
case 'move':
	$bRet = false;
	$unsharefile = array();
	
	$dfolder = base64_decode($toftpfolder);
	if ($ftphandle->folder_is_safe($dfolder) && $ftpfolder != $dfolder){
		if ($filename == '') {
			$pagesize = $session_value['preferences']['recodeperpage'];
			for ($i = 0; $i < $pagesize; $i++){
				$item = ${'item_'.$i};
				if ($item == '')
					continue;
					
				$filename = base64_decode($item);
				if ($ftphandle->folder_is_safe($filename)){
					$ftpfile = $ftpfolder;
					if (substr($ftpfile, -1) != '/')
						$ftpfile .= '/';
					$ftpfile .= $filename;
	
					$destfile = $dfolder;
					if (substr($destfile, -1) != '/')
						$destfile .= '/';
					$destfile .= $filename;
	
					if ($ftpfile != $dfolder && $ftpfile != $destfile){
						if ($ftphandle->move_folder_file($ftpfile, $destfile)) {
							$bRet = true;
							
							$ftp->DeleteShareFile($ftpfile);
						}
					}
				}
			}
		}
		else {
			$filename = base64_decode($filename);
			if ($ftphandle->folder_is_safe($filename)){
				$ftpfile = $ftpfolder;
				if (substr($ftpfile, -1) != '/')
					$ftpfile .= '/';
				$ftpfile .= $filename;

				$destfile = $dfolder;
				if (substr($destfile, -1) != '/')
					$destfile .= '/';
				$destfile .= $filename;

				if ($ftpfile != $dfolder && $ftpfile != $destfile){
					if ($ftphandle->move_folder_file($ftpfile, $destfile)) {
						$bRet = true;
						
						$ftp->DeleteShareFile($ftpfile);
					}
				}
			}
		}
	}

	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;
	break;
case 'writemail_attach':
	if(!file_exists($SYSTEM_DIRECTORY['temporary'].'_attachments')) {
		mkdir($SYSTEM_DIRECTORY['temporary'].'_attachments');
		chmod($SYSTEM_DIRECTORY['temporary'].'_attachments', 0775);
	}
		
	foreach ($session_value['attachments'] as &$item)
		@unlink($item['localname']);
	unset($session_value['attachments']);

	foreach ($session_value['embedfiles'] as &$item)
		@unlink($item['localname']);
	unset($session_value['embedfiles']);
	
	$bRet = false;
	if ($filename == '') {	
		$index = 0;
		$pagesize = $session_value['preferences']['recodeperpage'];
		for ($i = 0; $i < $pagesize; $i++){
			$item = ${'item_'.$i};
			if ($item == '')
				continue;

			$filename = base64_decode($item);
			if ($ftphandle->folder_is_safe($filename)){
				$ftpfile = $ftpfolder;
				if (substr($ftpfile, -1) != '/')
					$ftpfile .= '/';
				$ftpfile .= $filename;
				
				$ftpfullfile = $ftphandle->ftp_home_directory.$ftpfile;
				$localfile = $SYSTEM_DIRECTORY['temporary'].'_attachments'.DIRECTORY_SEPARATOR.$session_value['uid'].'_'.$sessid.'_'.md5($ftpfile);
				if (is_file($ftpfullfile) && @copy($ftpfullfile, $localfile)){
				  	if (file_exists($localfile))  {
						$filetype = 'application/octet-stream';
						$ipos = strrpos($filename, '.');
						if ($ipos !== false) {
							$suffix = substr($filename, $ipos);
							$suffix = strtolower($suffix);
							if (isset($mimetypes[$suffix]))
								$filetype = $mimetypes[$suffix];
						}
						
						$attach = array();
						$attach['localname'] = $localfile;
						$attach['name'] = $ftphandle->get_filename($filename, false);
						$attach['dispname'] = $ftphandle->get_filename($filename);
						$attach['type'] = $filetype;
						$attach['size'] = filesize($localfile);
						
						$session_value['attachments'][$index++] = $attach;
					
						$bRet = true;
				    }
				}
			}
		}
	}
	else {
		$filename = base64_decode($filename);
		if ($ftphandle->folder_is_safe($filename)){
			$ftpfile = $ftpfolder;
			if (substr($ftpfile, -1) != '/')
				$ftpfile .= '/';
			$ftpfile .= $filename;
	
			$ftpfullfile = $ftphandle->ftp_home_directory.$ftpfile;
			$localfile = $SYSTEM_DIRECTORY['temporary'].'_attachments'.DIRECTORY_SEPARATOR.$session_value['uid'].'_'.$sessid.'_'.md5($ftpfile);
			if (is_file($ftpfullfile) && @copy($ftpfullfile, $localfile)){
			  	if (file_exists($localfile))  {
					$filetype = 'application/octet-stream';
					$ipos = strrpos($filename, '.');
					if ($ipos !== false) {
						$suffix = substr($filename, $ipos);
						$suffix = strtolower($suffix);
						if (isset($mimetypes[$suffix]))
							$filetype = $mimetypes[$suffix];
					}
					
					$attach = array();
					$attach['localname'] = $localfile;
					$attach['name'] = $ftphandle->get_filename($filename, false);
					$attach['dispname'] = $ftphandle->get_filename($filename);
					$attach['type'] = $filetype;
					$attach['size'] = filesize($localfile);
					
					$session_value['attachments'][0] = $attach;
				
					$bRet = true;
			    }
			}
		}
	}
	
	$sesshandle->Save($session_value);

	do_redirect('main.php?sessid='.$sessid.'&act=newmsg&opt=netdisk&retid='.$retid);
	exit;

	break;
case 'writemail_link':
	if(!file_exists($SYSTEM_DIRECTORY['temporary'].'_attachments')) {
		mkdir($SYSTEM_DIRECTORY['temporary'].'_attachments');
		chmod($SYSTEM_DIRECTORY['temporary'].'_attachments', 0775);
	}
		
	foreach ($session_value['attachments'] as &$item)
		@unlink($item['localname']);
	unset($session_value['attachments']);

	foreach ($session_value['embedfiles'] as &$item)
		@unlink($item['localname']);
	unset($session_value['embedfiles']);
		
	$nowtime = time();
	$shareurl = $internet_location.'/viewsharenetdisk.php';
	$usercode = md5($session_value['uid'].'|'.$session_value['userid'].'|'.$session_value['createtime']);
	$urlpara = 'userid='.$session_value['uid'].'&usercode='.$usercode.'&opt=download&start='.$nowtime;

	if ($filename == '') {
		$index = 0;
		$pagesize = $session_value['preferences']['recodeperpage'];
		for ($i = 0; $i < $pagesize; $i++){
			$item = ${'item_'.$i};
			if ($item == '')
				continue;

			$filename = base64_decode($item);
			if ($ftphandle->folder_is_safe($filename)){
				$ftpfile = $ftpfolder;
				if (substr($ftpfile, -1) != '/')
					$ftpfile .= '/';
				$ftpfile .= $filename;
				
				if ($ftphandle->is_file($ftpfile)) {
					$fileInfo = $ftphandle->get_folder_info($ftpfile);
					
					$chksum = md5($session_value['uid'].'|'.$ftpfile.'|'.$nowtime);
					$itemcode = md5($chksum.'|'.$session_value['userid'].'|'.$session_value['createtime']);
					$linkpara = $urlpara.'&filename='.base64_encode($ftpfile).'&chksum='.$chksum.'&itemcode='.$itemcode;
					$downlink = $shareurl.'?f='.base64_encode($linkpara);
		
					$attach = array();
					$attach['downlink'] = $downlink;
					$attach['name'] = $ftphandle->get_filename($filename, false);
					$attach['dispname'] = $ftphandle->get_filename($filename);
					$attach['type'] = 'link/file';
					$attach['size'] = ($fileInfo['size'] >= 0) ? $fileInfo['size'] : 0;
		
					$session_value['attachments'][$index++] = $attach;
		
					$bRet = true;
				}
			}
		}
	}
	else {
		$filename = base64_decode($filename);
		if ($ftphandle->folder_is_safe($filename)){
			$ftpfile = $ftpfolder;
			if (substr($ftpfile, -1) != '/')
				$ftpfile .= '/';
			$ftpfile .= $filename;
			
			if ($ftphandle->is_file($ftpfile)) {
				$fileInfo = $ftphandle->get_folder_info($ftpfile);
				
				$chksum = md5($session_value['uid'].'|'.$ftpfile.'|'.$nowtime);
				$itemcode = md5($chksum.'|'.$session_value['userid'].'|'.$session_value['createtime']);
				$linkpara = $urlpara.'&filename='.base64_encode($ftpfile).'&chksum='.$chksum.'&itemcode='.$itemcode;
				$downlink = $shareurl.'?f='.base64_encode($linkpara);
					
				$attach = array();
				$attach['downlink'] = $downlink;
				$attach['name'] = $ftphandle->get_filename($filename, false);
				$attach['dispname'] = $ftphandle->get_filename($filename);
				$attach['type'] = 'link/file';
				$attach['size'] = ($fileInfo['size'] >= 0) ? $fileInfo['size'] : 0;
		
				$session_value['attachments'][0] = $attach;
				
				$bRet = true;
			}
		}
	}
	
	$sesshandle->Save($session_value);
	
	do_redirect('main.php?sessid='.$sessid.'&act=newmsg&opt=netdisk&retid='.$retid);			
	exit;
	break;
case 'share':
	$bRet = false;

	if ($filename == '') {
		$pagesize = $session_value['preferences']['recodeperpage'];
		for ($i = 0; $i < $pagesize; $i++){
			$item = ${'item_'.$i};
			if ($item == '')
				continue;

			$filename = base64_decode($item);
			if ($ftphandle->folder_is_safe($filename)){
				$ftpfile = $ftpfolder;
				if (substr($ftpfile, -1) != '/')
					$ftpfile .= '/';
				$ftpfile .= $filename;
	
				if ($ftp->AddShareFile($ftpfile) == 0)
					$bRet = true;
			}
		}
	}
	else {
		$filename = base64_decode($filename);
		if ($ftphandle->folder_is_safe($filename)){
			$ftpfile = $ftpfolder;
			if (substr($ftpfile, -1) != '/')
				$ftpfile .= '/';
			$ftpfile .= $filename;

			if ($ftp->AddShareFile($ftpfile) == 0)
				$bRet = true;
		}
	}

	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;
	break;
case 'unshare':
	$bRet = false;
	
	if ($filename == '') {
		$pagesize = $session_value['preferences']['recodeperpage'];
		for ($i = 0; $i < $pagesize; $i++){
			$item = ${'item_'.$i};
			if ($item == '')
				continue;

			$filename = base64_decode($item);
			if ($ftphandle->folder_is_safe($filename)){
				$ftpfile = $ftpfolder;
				if (substr($ftpfile, -1) != '/')
					$ftpfile .= '/';
				$ftpfile .= $filename;
	
				$bRet |= $ftp->DeleteShareFile($ftpfile);
			}
		}
	}
	else {
		$filename = base64_decode($filename);
		if ($ftphandle->folder_is_safe($filename)){
			$ftpfile = $ftpfolder;
			if (substr($ftpfile, -1) != '/')
				$ftpfile .= '/';
			$ftpfile .= $filename;

			$bRet = $ftp->DeleteShareFile($ftpfile);
		}
	}
	
	echo json_encode(array('result' => ($bRet ? 'ok' : 'err')));
	exit;
	break;
case 'changefolder':
case 'enterfolder':
case 'refresh':
	if ($opt == 'refresh') {
		$info = $ftphandle->get_folder_info('');
		if ($info != false)
			$ftphandle->reset_ftp_quota($info['size'], $info['file']);
	}
	else if ($opt == 'changefolder') {
		$ftpfolder = base64_decode($toftpfolder);
	}
	else {
		if ($toftpfolder != '^|^'){
			$toftpfolder = base64_decode($toftpfolder);				
			if (substr($ftpfolder, -1) != '/')
				$ftpfolder .= '/';
			$ftpfolder .= $toftpfolder;			
		}
		else{
			$iPos = strrpos($ftpfolder, '/');
			if ($iPos !== false)
				$ftpfolder = substr($ftpfolder, 0, $iPos);
		}
	}
	
	if (!$ftphandle->folder_is_safe($ftpfolder))
		$ftpfolder = '/';

	$pag = 0;
default:
	if (empty($ftpfolder))
		$ftpfolder = '/';
	
	$bSaveSession = false;
	$bSaveCache = false;
	$bReadList = false;
	if (intval($pag) <= 1 || !isset($sesscache_value['ftplist']) || $refresh == 'true')
		$bReadList = true;

	if (empty($sortby) || empty($sortorder)) {
		$sortby = $session_value['ftplist_sort']['sortby'];
		$sortorder = $session_value['ftplist_sort']['sortorder'];
	
		if (empty($sortby))
			$sortby = 'date';
		if (empty($sortorder))
			$sortorder = 'DESC';
	}
	else{
		 if ($session_value['ftplist_sort']['sortby'] != $sortby
			|| $session_value['ftplist_sort']['sortorder'] != $sortorder){
			$session_value['ftplist_sort']['sortby'] = $sortby;
			$session_value['ftplist_sort']['sortorder'] = $sortorder;
		
			$bReadList = true;
			$bSaveSession = true;
		}
	}
	
	if ($bReadList){
		$ftphandle->get_file_list($ftpfolder, $folderList, $fileList, $folderInfo);

		if ($sortby != 'date')	{
			if ($sortby == 'size')
				$neworder = $sortorder.'_NUM';
			else
				$neworder = $sortorder.'_UTF8';
			array_sort($folderList, $sortby, $neworder, 'date', 'DESC_NUM');
			array_sort($fileList, $sortby, $neworder, 'date', 'DESC_NUM');
		}
		else{
			$neworder = $sortorder.'_NUM';
			array_sort($folderList, $sortby, $neworder);
			array_sort($fileList, $sortby, $neworder);
		}
		
		$sesscache_value['ftplist']['ftpfolder'] = $ftpfolder;
		$sesscache_value['ftplist']['info'] = $folderInfo;
		$sesscache_value['ftplist']['folder'] = $folderList;
		$sesscache_value['ftplist']['file'] = $fileList;
		
		$bSaveCache = true;
	}
	else {
		$folderInfo = $sesscache_value['ftplist']['info'];
		$folderList = $sesscache_value['ftplist']['folder'];
		$fileList = $sesscache_value['ftplist']['file'];
	}

	if (!isset($sesscache_value['ftpfolders']) || $refresh == 'true') {
		$allFolders = $ftphandle->get_all_folder('');
		$allFolders = $ftphandle->get_filename($allFolders);
		
		$sesscache_value['ftpfolders'] = $allFolders;
		$bSaveCache = true;
	}
	else {
		$allFolders = $sesscache_value['ftpfolders']; 
	}

	if ($bSaveSession)
		$sesshandle->Save($session_value);

	if ($bSaveCache)
		$cachehandle->Save($sesscache_value);

	$numfile = $folderInfo['foldercount'] + $folderInfo['filecount'];
	$pagesize = $session_value['preferences']['recodeperpage'];
	$totalpage = ceil($numfile/$pagesize);

	if (!isset($pag) || intval($pag) == 0) 
		$pag = 1;
	else if ($totalpage && $pag > $totalpage)
		$pag = $totalpage;

	$pageinfo = '';
	$navigation = '';
	if($numfile > 0 && $totalpage > 1) {
		if($pag > 1) {
			$smarty->assign('FirstLink', 'javascript: o_ftp.chgpage(\'1\');');
			$smarty->assign('PreviousLink', 'javascript: o_ftp.chgpage(\''.($pag-1).'\');');
		}
		
		$navigation = '<select onchange="javascript: o_ftp.chgpage(this.options[this.selectedIndex].value);">';
		for($i = 1; $i <= $totalpage; $i++) {
			if($pag == $i)
				$navigation .= '<option value="'.$i.'" selected>'.$i.'</option> ';
			else 
				$navigation .= '<option value="'.$i.'">'.$i.'</option> ';
		}
		$navigation .= '</select>';
	
		if($pag < $totalpage) {
			$smarty->assign('NextLink', 'javascript: o_ftp.chgpage(\''.($pag+1).'\');');
			$smarty->assign('LastLink', 'javascript: o_ftp.chgpage(\''.$totalpage.'\');');
		}
		
		$pageinfo = sprintf($page_information, $pag, $totalpage);
	}
	
	$smarty->assign('PageInfo', $pageinfo);	
	$smarty->assign('Page', $pag);
	$smarty->assign('TotalPage', $totalpage);
	$smarty->assign('NavBar', $navigation);
	$smarty->assign('NumFtpFiles', $numfile);

	$arrowimg = ($sortorder == 'ASC') ? 'images/arrow_up.gif' : 'images/arrow_down.gif';
	$arrow = '&nbsp;<img src="'.$arrowimg.'" width=8 height=7 border=0>';

	$name_arrow = '';
	$date_arrow = '';
	$size_arrow = '';
	
	switch($sortby) {
	case 'name':
		$name_arrow = $arrow;
		break;
	default:
	case 'date':
		$date_arrow = $arrow;
		break;
	case 'size':
		$size_arrow = $arrow;
		break;
	}
	
	$smarty->assign('NameArrow', $name_arrow);
	$smarty->assign('DateArrow', $date_arrow);
	$smarty->assign('SizeArrow', $size_arrow);
	$smarty->assign('SortBy', $sortby);
	$smarty->assign('SortOrder', $sortorder);

	$smarty->assign('DispFtpFolder', $ftphandle->get_filename($ftpfolder));
	$smarty->assign('AvalFtpFolders', $allFolders);
	$smarty->assign('NumAvalFtpFolders', count($allFolders));

	$tempList = array();
	for ($i = 0; $i < $folderInfo['foldercount']; $i++)
		$tempList[] = $folderList[$i];
	for ($i = 0; $i < $folderInfo['filecount']; $i++)
		$tempList[] = $fileList[$i];

	unset($folderList);
	unset($fileList);
	
	$shareFtpFile = $ftp->GetAllShareFile();
	$ftpfile = $ftpfolder;
	if (substr($ftpfile, -1) != '/')
		$ftpfile .= '/';

	$sharelink = '';
	if (is_array($shareFtpFile) && count($shareFtpFile) > 0){
		$shareurl = $internet_location.'/viewsharenetdisk.php';
	    $urlpara = 'userid='.$session_value['uid'].'&usercode='.md5($session_value['uid'].'|'.$session_value['userid'].'|'.$session_value['createtime']);
		$sharelink = $shareurl.'?f='.base64_encode($urlpara);
	}
	$smarty->assign('ShareLink', $sharelink);
	
	$dispList = array();
	for($i = ($pag-1)*$pagesize, $count = 0; $count < $pagesize && $i < $numfile; $i++) {
		if ($tempList[$i]['isdir']) {
			$tempList[$i]['iconfile'] = ICON_PATH.'folder.gif';
		}
		else {
			$file = $tempList[$i]['name'];
			$iconname = $iconfile = '';
			$ipos = strrpos($file, '.');
			if ($ipos !== false) {
				$iconname = substr($file, $ipos+1);
				$iconname = strtolower($iconname);

				$iconfile = ICON_PATH.$iconname.'.gif';
			}
			
			if (empty($iconfile) || !file_exists($iconfile))
				$iconfile = ICON_PATH.'unknown.gif';

			$tempList[$i]['iconfile'] = $iconfile;
		}

		$tempList[$i]['isshare'] = false;
		foreach ($shareFtpFile as &$shareitem){
			if ($shareitem['name'] == $ftpfile.$tempList[$i]['name']) {
				$fileid = base64_encode($shareitem['name']);
				$linkpara = $urlpara.'&filename='.$fileid.'&itemcode='.md5($fileid.'|'.$session_value['userid'].'|'.$session_value['createtime']);

				$sharelink = $shareurl.'?f='.base64_encode($linkpara);
				
				$tempList[$i]['isshare'] = true;
				$tempList[$i]['sharelink'] = $sharelink;
				break;
			}
		}

		$tempList[$i]['name'] = $ftphandle->get_filename($tempList[$i]['name']);
		$tempList[$i]['date'] = convert(strftime($datetime_format, $tempList[$i]['date']));
		$tempList[$i]['size'] = format_size_string($tempList[$i]['size']);

		$tempList[$i]['preview'] = (isset($mimetypes['.'.$iconname])) ? true : false;
		
		$tempList[$i]['downlink'] = 'main.php?sessid='.$sessid.'&act=netdisk&opt=download&ftpfolder='.urlencode(base64_encode($ftpfolder)).'&filename='.urlencode($tempList[$i]['id']).'&retid='.$retid;

		if ($tempList[$i]['preview'] == true) {
			if ($document_converter && in_array('.'.$iconname, $mimeconvert)) {
				$tempList[$i]['converter'] = 1;
				$tempList[$i]['viewlink'] = sprintf($document_converter, urlencode($internet_location.'/'.$tempList[$i]['downlink']));
			}
			else if ($session_value['isapp'] == 1) {
				$tempList[$i]['viewlink'] = $tempList[$i]['downlink'];
			}
			else {
				$tempList[$i]['viewlink'] = 'main.php?sessid='.$sessid.'&act=netdisk&opt=preview&ftpfolder='.urlencode(base64_encode($ftpfolder)).'&filename='.urlencode($tempList[$i]['id']).'&retid='.$retid;
			}
		}

		if ($session_value['isapp'] == 1) {
			$url = base64_encode($ftpfolder).':'.$tempList[$i]['id'].':0:'.$tempList[$i]['name'];
			$tempList[$i]['downlink'] = 'javascript:app_download(\'netdisk\', \''.base64_encode($url).'\');';
		}
		
		$dispList[$count++] = $tempList[$i];
	}
	unset($tempList);
	
	if ($ftpfolder == '' || $ftpfolder == '/')
		$smarty->assign('DispUpFolder', '0');
	else
		$smarty->assign('DispUpFolder', '1');
	
	$smarty->assign('FileList', $dispList);
	
	$size = $folderInfo['totalused'];
	$dispsize = format_size_string($size);
	
	$smarty->assign('FolderCount', $folderInfo['foldercount']);
	$smarty->assign('FileCount', $folderInfo['filecount']);
	$smarty->assign('TotalUsed', $dispsize);

	$quota_limit = $session_value['ftpquota'];
	$quota_enabled = ($quota_limit) ? 1 : 0;
	
	$arrFtpSize = $ftphandle->get_ftp_quota();
	$totalused = $arrFtpSize['usedftpquota'];
	
	$disptotalused = format_size_string($totalused);
	if ($quota_enabled) {
		$usageGraph = get_usage_graphic($totalused, $quota_limit, $quota_usedrate);
		$dispquotalimit = format_size_string($quota_limit);
	}
	
	$smarty->assign('QuotaEnabled', $quota_enabled);
	$smarty->assign('QuotaLimit', $dispquotalimit);
	$smarty->assign('QuotaUsed', $disptotalused);

	$smarty->assign('AdvanceUploader', $advance_uploader && ($session_value['preferences']['uploader'] != 'normal'));

	$upload_max_size = $upload_maxsize*1024*1024;
	$ini_max_size = get_max_upload(ini_get('post_max_size'));
	if ($ini_max_size && $upload_max_size > $ini_max_size)
		$upload_max_size = $ini_max_size;
	$ini_max_size = get_max_upload(ini_get('upload_max_filesize'));
	if ($ini_max_size && $upload_max_size > $ini_max_size)
		$upload_max_size = $ini_max_size;

	$netdiskfull = false;
	if ($quota_enabled && $quota_limit) {
		if ($quota_limit > $totalused) {
			$availspace = $quota_limit-$totalused;
			if ($upload_max_size == 0 || $upload_max_size > $availspace)
				$upload_max_size = $availspace;
		}
		else {
			$netdiskfull = true;
		}
	}

	$smarty->assign('NetdiskFull', $netdiskfull);

	$smarty->assign('UploadMaxSize', $upload_max_size);
	$smarty->assign('DisplayUploadMaxSize', format_size_string($upload_max_size, true));

	$smarty->assign('CloudAttachDays', $cloudattach_day);
	
	$templatename = 'netdisk-list.htm';
	
	break;
}

$smarty->assign('FtpFolder', base64_encode($ftpfolder));
$smarty->assign('Page', $pag);

$display_page = $selected_theme.'/'.$templatename;

?>